diff -uNr mythtv-0.21/libs/libmythtv/mhi.cpp mythtv/libs/libmythtv/mhi.cpp
--- mythtv-0.21/libs/libmythtv/mhi.cpp	2007-12-11 15:56:01.000000000 +0100
+++ mythtv/libs/libmythtv/mhi.cpp	2008-12-11 23:59:27.000000000 +0100
@@ -36,7 +36,8 @@
       m_face_loaded(false), m_currentChannel(-1),
       m_isLive(false),      m_currentCard(0),
       m_audioTag(-1),       m_videoTag(-1),
-      m_tuningTo(-1),       m_lastNbiVersion(NBI_VERSION_UNSET)
+      m_tuningTo(-1),       m_lastNbiVersion(NBI_VERSION_UNSET),
+      m_videoRect(0, 0, StdDisplayWidth, StdDisplayHeight)
 {
     m_display.setAutoDelete(true);
     m_dsmccQueue.setAutoDelete(true);
@@ -402,6 +403,7 @@
 {
     m_displayWidth = display.width();
     m_displayHeight = display.height();
+    m_videoRect = display; // Assume full screen at this stage.
 }
 
 void MHIContext::SetInputRegister(int num)
@@ -452,7 +454,51 @@
 void MHIContext::AddToDisplay(const QImage &image, int x, int y)
 {
     MHIImageData *data = new MHIImageData;
-    data->m_image = image;
+    // It seems that OSDTypeImage::Load doesn't deal well with images
+    // located on odd pixel boundaries and the resulting display contains
+    // transparent lines.  To avoid this we create a new image if either
+    // the x or y offset would be odd and set the extra pixels to transparent.
+    QImage img = image;
+    int xboundary = x & 1;
+    int yboundary = y & 1;
+    
+    if (xboundary || yboundary)
+    {
+        int width = img.width(), height = img.height();
+        if (xboundary)
+        {
+            width++;
+            x--;
+        }
+        if (yboundary)
+        {
+            height++;
+            y--;
+        }
+        img = QImage(width, height, 32);
+        img.setAlphaBuffer(true);
+        QRgb qTransparent = qRgba(0,0,0,0);
+        if (xboundary)
+        {
+            for (int i = 0; i < height; i++)
+                img.setPixel(0, i, qTransparent);
+        }
+
+        if (yboundary)
+        {
+            for (int j = 0; j < width; j++)
+                img.setPixel(j, 0, qTransparent);
+        }
+
+        for (int i = 0; i < height-yboundary; i++)
+        {
+            for (int j = 0; j < width-xboundary; j++)
+            {
+                img.setPixel(j+xboundary, i+yboundary, image.pixel(j,i));
+            }
+        }
+    }
+    data->m_image = img;
     data->m_x = x;
     data->m_y = y;
     QMutexLocker locker(&m_display_lock);
@@ -470,7 +516,17 @@
 {
     // tell the video player to resize the video stream
     if (m_parent->GetNVP())
-        m_parent->GetNVP()->SetVideoResize(videoRect);
+    {
+        QRect vidRect(videoRect.x() * m_displayWidth/StdDisplayWidth,
+                      videoRect.y() * m_displayHeight/StdDisplayHeight,
+                      videoRect.width() * m_displayWidth/StdDisplayWidth,
+                      videoRect.height() * m_displayHeight/StdDisplayHeight);
+        if (m_videoRect != vidRect)
+        {
+            m_parent->GetNVP()->SetVideoResize(vidRect);
+            m_videoRect = vidRect;
+        }
+    }
 
     QMutexLocker locker(&m_display_lock);
     QRect displayRect(dispRect.x() * m_displayWidth/StdDisplayWidth,
@@ -713,15 +769,11 @@
     QRgb qColour = qRgba(colour.red(), colour.green(),
                          colour.blue(), colour.alpha());
 
-    // This is a bit of a mess: we should be able to create a rectangle object.
-    // Scale the image to the current display size
     int scaledWidth = width * GetWidth() / MHIContext::StdDisplayWidth;
     int scaledHeight = height * GetHeight() / MHIContext::StdDisplayHeight;
     QImage qImage(scaledWidth, scaledHeight, 32);
     qImage.setAlphaBuffer(true);
 
-    // As far as I can tell this is the only way to draw with an
-    // intermediate transparency.
     for (int i = 0; i < scaledHeight; i++)
     {
         for (int j = 0; j < scaledWidth; j++)
@@ -1252,6 +1304,8 @@
 // The UK profile says that MHEG should not contain concave or
 // self-crossing polygons but we can get the former at least as
 // a result of rounding when drawing ellipses.
+typedef struct { int yBottom, yTop, xBottom; float slope; } lineSeg;
+
 void MHIDLA::DrawPoly(bool isFilled, const QPointArray &points)
 {
     int nPoints = points.size();
@@ -1260,116 +1314,73 @@
 
     if (isFilled)
     {
-        // Polygon filling is done by sketching the outline of
-        // the polygon in a separate bitmap and then raster scanning
-        // across this to generate the fill.  There are some special
-        // cases that have to be considered when doing this.  Maximum
-        // and minimum points have to be removed otherwise they will
-        // turn the scan on but not off again.  Horizontal lines are
-        // suppressed and their ends handled specially.
-        QRect bounds = points.boundingRect();
-        int width = bounds.width()+1, height = bounds.height()+1;
-        QBitArray boundsMap(width*height);
-        boundsMap.fill(0);
-        // Draw the boundaries in the bounds map.  This is
-        // the Bresenham algorithm if the absolute gradient is
-        // greater than 1 but puts only the centre of each line
-        // (so there is only one point for each y value) if less.
-        QPoint last = points[nPoints-1]; // Last point
-        for (int i = 0; i < nPoints; i++)
-        {
-            QPoint thisPoint = points[i];
-            int x1 = last.x() - bounds.x();
-            int y1 = last.y() - bounds.y();
-            int x2 = thisPoint.x() - bounds.x();
-            int y2 = thisPoint.y() - bounds.y();
-            int x, xEnd, y, yEnd;
-            if (y2 > y1)
+        QMemArray <lineSeg> lineArray(nPoints);
+        int nLines = 0;
+        // Initialise the line segment array.  Include all lines
+        // apart from horizontal.  Close the polygon by starting
+        // with the last point in the array.
+        int lastX = points[nPoints-1].x(); // Last point
+        int lastY = points[nPoints-1].y();
+        int yMin = lastY, yMax = lastY;
+        for (int k = 0; k < nPoints; k++)
+        {
+            int thisX = points[k].x();
+            int thisY = points[k].y();
+            if (lastY != thisY)
             {
-                x = x1;
-                y = y1;
-                xEnd = x2;
-                yEnd = y2;
-            }
-            else
-            {
-                x = x2;
-                y = y2;
-                xEnd = x1;
-                yEnd = y1;
-            }
-            int dx = abs(xEnd-x), dy = yEnd-y;
-            int xStep = xEnd >= x ? 1 : -1;
-            if (abs(y2-y1) > abs(x2-x1))
-            {
-                int error = dy/2;
-                y++;
-                for (; y < yEnd; y++) // Exclude endpoints
+                if (lastY > thisY)
                 {
-                    boundsMap.toggleBit(x+y*width);
-                    error += dx;
-                    if (error*2 > dy)
-                    {
-                        error -= dy;
-                        x += xStep;
-                    }
+                    lineArray[nLines].yBottom = thisY;
+                    lineArray[nLines].yTop = lastY;
+                    lineArray[nLines].xBottom = thisX;
                 }
-            }
-            else
-            {
-                int error = 0;
-                y++;
-                for (; y < yEnd; y++)
+                else
                 {
-                    boundsMap.toggleBit(x+y*width);
-                    error += dx;
-                    while (error > dy)
-                    {
-                        x += xStep;
-                        error -= dy;
-                    }
+                    lineArray[nLines].yBottom = lastY;
+                    lineArray[nLines].yTop = thisY;
+                    lineArray[nLines].xBottom = lastX;
                 }
+                lineArray[nLines++].slope =
+                    (float)(thisX-lastX) / (float)(thisY-lastY);
             }
-            QPoint nextPoint = points[(i+1) % nPoints];
-            int nextY = nextPoint.y() - bounds.y();
-            int turn = (y2 - y1) * (nextY - y2);
-            if (turn > 0) // Not a max or min
-                boundsMap.toggleBit(x2+y2*width);
-            else if (turn == 0) // Previous or next line is horizontal
+            if (thisY < yMin)
+                yMin = thisY;
+            if (thisY > yMax)
+                yMax = thisY;
+            lastX = thisX;
+            lastY = thisY;
+        }
+        
+        // Find the intersections of each line in the line segment array
+        // with the scan line.  Because UK MHEG says that figures should be
+        // convex we only need to consider two intersections.
+        QRgb fillColour = qRgba(m_fillColour.red(), m_fillColour.green(),
+                                m_fillColour.blue(), m_fillColour.alpha());
+        for (int y = yMin; y < yMax; y++)
+        {
+            int crossings = 0, xMin = 0, xMax = 0;
+            for (int l = 0; l < nLines; l++)
             {
-                // We only draw a point at the beginning or end of a horizontal
-                // line if it turns clockwise.  This means that the fill
-                // will be different depending on the direction the polygon was
-                // drawn but that will be tidied up when we draw the lines round.
-                if (y1 == y2)
+                if (y >= lineArray[l].yBottom && y < lineArray[l].yTop)
                 {
-                    if ((x2-x1) * (nextY - y2) > 0)
-                       boundsMap.toggleBit(x2+y2*width);
+                    int x = (int)round((float)(y - lineArray[l].yBottom) * 
+                        lineArray[l].slope) + lineArray[l].xBottom;
+                    if (crossings == 0 || x < xMin)
+                        xMin = x;
+                    if (crossings == 0 || x > xMax)
+                        xMax = x;
+                    crossings++;
                 }
-                else if ((nextPoint.x() - bounds.x() - x2) * (y2 - y1) < 0)
-                    // Next line is horizontal -  draw point if turn is clockwise.
-                    boundsMap.toggleBit(x2+y2*width);
             }
-            last = thisPoint;
-        }
-        QRgb fillColour = qRgba(m_fillColour.red(), m_fillColour.green(),
-                                m_fillColour.blue(), m_fillColour.alpha());
-        // Now scan the bounds map and use this to fill the polygon.
-        for (int j = 0; j < bounds.height(); j++)
-        {
-            bool penDown = false;
-            for (int k = 0; k < bounds.width(); k++)
+            if (crossings == 2)
             {
-                if (boundsMap.testBit(k+j*width))
-                    penDown = ! penDown;
-                else if (penDown && k+bounds.x() >= 0 && j+bounds.y() >= 0 &&
-                         k+bounds.x() < m_width && j+bounds.y() < m_height)
-                    m_image.setPixel(k+bounds.x(), j+bounds.y(), fillColour);
+                for (int x = xMin; x <= xMax; x++)
+                    m_image.setPixel(x, y, fillColour);
             }
         }
 
         // Draw the boundary
-        last = points[nPoints-1]; // Last point
+        QPoint last = points[nPoints-1]; // Last point
         for (int i = 0; i < nPoints; i++)
         {
             DrawLine(points[i].x(), points[i].y(), last.x(), last.y());
@@ -1394,8 +1405,7 @@
             return;
         // Construct an image the size of the bounding box and tile the
         // bitmap over this.
-        QImage tiledImage = QImage(rect.width(), rect.height(),
-                                   m_image.depth());
+        QImage tiledImage = QImage(rect.width(), rect.height(), 32);
 
         for (int i = 0; i < rect.width(); i += m_image.width())
         {
@@ -1536,3 +1546,5 @@
 
     m_image = m_image.smoothScale(newWidth, newHeight);
 }
+
+
diff -uNr mythtv-0.21/libs/libmythtv/mhi.h mythtv/libs/libmythtv/mhi.h
--- mythtv-0.21/libs/libmythtv/mhi.h	2007-04-18 21:45:41.000000000 +0200
+++ mythtv/libs/libmythtv/mhi.h	2008-12-11 23:59:27.000000000 +0100
@@ -180,6 +180,8 @@
 
     uint             m_lastNbiVersion;
     QMemArray<unsigned char> m_nbiData;
+    
+    QRect            m_videoRect;
 };
 
 // Object for drawing text.
diff -uNr mythtv-0.21/libs/libmythtv/mpeg/atscstreamdata.h mythtv/libs/libmythtv/mpeg/atscstreamdata.h
--- mythtv-0.21/libs/libmythtv/mpeg/atscstreamdata.h	2006-07-09 00:28:30.000000000 +0200
+++ mythtv/libs/libmythtv/mpeg/atscstreamdata.h	2009-01-17 09:23:55.000000000 +0100
@@ -113,6 +113,7 @@
     void CacheMGT(MasterGuideTable*);
     void CacheTVCT(uint pid, TerrestrialVirtualChannelTable*);
     void CacheCVCT(uint pid, CableVirtualChannelTable*);
+  protected:
     virtual void DeleteCachedTable(PSIPTable *psip) const;
 
   private:
diff -uNr mythtv-0.21/libs/libmythtv/mpeg/dvbdescriptors.cpp mythtv/libs/libmythtv/mpeg/dvbdescriptors.cpp
--- mythtv-0.21/libs/libmythtv/mpeg/dvbdescriptors.cpp	2007-12-16 19:15:42.000000000 +0100
+++ mythtv/libs/libmythtv/mpeg/dvbdescriptors.cpp	2008-08-30 22:55:53.000000000 +0200
@@ -1,5 +1,6 @@
 #include "dvbdescriptors.h"
 #include "iso6937tables.h"
+#include "freesat_huffman.h"
 
 #include <unistd.h>
 #include <qtextcodec.h>
@@ -70,6 +71,9 @@
     if (!raw_length)
         return "";
 
+    if (src[0] == 0x1f)
+        return freesat_huffman_to_string(src, raw_length);
+
     if ((0x10 < src[0]) && (src[0] < 0x20))
     {
         // TODO: Handle multi-byte encodings
@@ -78,13 +82,16 @@
         return "";
     }
 
-    // Strip formatting characters
-    // Also, if a override encoding is specified copy it in front of the text
+    // if a override encoding is specified and the default ISO 6937 encoding
+    // would be used copy the ovverride encoding in front of the text
     unsigned char dst[raw_length + encoding_override_length];
-    uint length = encoding_override_length;
-    if (encoding_override)
+    uint length = 0;
+    if (encoding_override && src[0] >= 0x20) {
         memcpy(dst, encoding_override, encoding_override_length);
+        length = encoding_override_length;
+    }
     
+    // Strip formatting characters
     for (uint i = 0; i < raw_length; i++)
     {
         if ((src[i] < 0x80) || (src[i] > 0x9F))
diff -uNr mythtv-0.21/libs/libmythtv/mpeg/dvbdescriptors.h mythtv/libs/libmythtv/mpeg/dvbdescriptors.h
--- mythtv-0.21/libs/libmythtv/mpeg/dvbdescriptors.h	2008-01-14 19:58:41.000000000 +0100
+++ mythtv/libs/libmythtv/mpeg/dvbdescriptors.h	2009-01-03 15:32:38.000000000 +0100
@@ -1297,7 +1297,8 @@
         kServiceTypeRCS_Map                  = 0x0E,
         kServiceTypeRCS_FLS                  = 0x0F,
         kServiceTypeDVB_MHP                  = 0x10,
-        kServiceTypeHDTV                     = 0x19,
+        kServiceTypeHDTV                     = 0x11,
+        kServiceTypeHDTV2                    = 0x19,
         kServiceTypeEchoStarTV1              = 0x91,
         kServiceTypeEchoStarTV2              = 0x9a,
         kServiceTypeEchoStarTV3              = 0xa4,
@@ -1348,7 +1349,9 @@
     bool IsDigitalAudio(void) const
         { return ServiceType() ==  kServiceTypeDigitalRadioSound; }
     bool IsHDTV(void) const
-        { return ServiceType() ==  kServiceTypeHDTV; }
+        { return
+	    (ServiceType() ==  kServiceTypeHDTV) ||
+	    (ServiceType() ==  kServiceTypeHDTV2); }
     bool IsTeletext(void) const
         { return ServiceType() ==  kServiceTypeDataBroadcast; }
 
diff -uNr mythtv-0.21/libs/libmythtv/mpeg/dvbstreamdata.cpp mythtv/libs/libmythtv/mpeg/dvbstreamdata.cpp
--- mythtv-0.21/libs/libmythtv/mpeg/dvbstreamdata.cpp	2008-02-27 00:37:42.000000000 +0100
+++ mythtv/libs/libmythtv/mpeg/dvbstreamdata.cpp	2009-01-17 09:23:55.000000000 +0100
@@ -9,6 +9,7 @@
 #include "eithelper.h"
 
 #define PREMIERE_ONID 133
+#define FREESAT_EIT_PID 3842
 
 // service_id is synonymous with the MPEG program number in the PMT.
 DVBStreamData::DVBStreamData(uint desired_netid,  uint desired_tsid,
@@ -97,7 +98,7 @@
         return false;
 
     bool is_eit = false;
-    if (DVB_EIT_PID == pid)
+    if (DVB_EIT_PID == pid || FREESAT_EIT_PID == pid)
     {
         // Standard Now/Next Event Information Tables for this transport
         is_eit |= TableID::PF_EIT  == table_id;
@@ -130,7 +131,7 @@
         return SDToSectionSeen(psip.TableIDExtension(), psip.Section());
     }
 
-    if (DVB_EIT_PID == pid)
+    if (DVB_EIT_PID == pid || FREESAT_EIT_PID == pid)
     {
         // Standard Now/Next Event Information Tables for other transport
         is_eit |= TableID::PF_EITo == table_id;
@@ -327,7 +328,7 @@
         }
     }
 
-    if ((DVB_EIT_PID == pid || DVB_DNLONG_EIT_PID == pid) &&
+    if ((DVB_EIT_PID == pid || DVB_DNLONG_EIT_PID == pid || FREESAT_EIT_PID == pid) &&
         DVBEventInformationTable::IsEIT(psip.TableID()))
     {
         QMutexLocker locker(&_listener_lock);
@@ -428,6 +429,12 @@
         {
             add_pids.push_back(PREMIERE_EIT_SPORT_PID);
         }
+
+        if (find(cur_pids.begin(), cur_pids.end(),
+                 (uint) FREESAT_EIT_PID) == cur_pids.end())
+        {
+            add_pids.push_back(FREESAT_EIT_PID);
+        }
     }
     else
     {
@@ -457,6 +464,12 @@
         {
             del_pids.push_back(PREMIERE_EIT_SPORT_PID);
         }
+
+        if (find(cur_pids.begin(), cur_pids.end(),
+                 (uint) FREESAT_EIT_PID) == cur_pids.end())
+        {
+            del_pids.push_back(FREESAT_EIT_PID);
+        }
     }
 
     return add_pids.size() || del_pids.size();
@@ -768,6 +781,42 @@
     sdts.clear();
 }
 
+void DVBStreamData::DeleteCachedTable(PSIPTable *psip) const
+{
+    if (!psip)
+        return;
+
+    uint tid = psip->TableIDExtension();
+
+    QMutexLocker locker(&_cache_lock);
+    if (_cached_ref_cnt[psip] > 0)
+    {
+        _cached_slated_for_deletion[psip] = 1;
+        return;
+    }
+    else if ((TableID::NIT == psip->TableID()) &&
+             _cached_nit[psip->Section()])
+    {
+        _cached_nit[psip->Section()] = NULL;
+        delete psip;
+    }
+    else if ((TableID::SDT == psip->TableID()) &&
+             _cached_sdts[tid << 8 | psip->Section()])
+    {
+        _cached_sdts[tid << 8 | psip->Section()] = NULL;
+        delete psip;
+    }
+    else
+    {
+        MPEGStreamData::DeleteCachedTable(psip);
+        return;
+    }
+    psip_refcnt_map_t::iterator it;
+    it = _cached_slated_for_deletion.find(psip);
+    if (it != _cached_slated_for_deletion.end())
+        _cached_slated_for_deletion.erase(it);
+}
+
 void DVBStreamData::CacheNIT(NetworkInformationTable *nit)
 {
     QMutexLocker locker(&_cache_lock);
diff -uNr mythtv-0.21/libs/libmythtv/mpeg/dvbstreamdata.h mythtv/libs/libmythtv/mpeg/dvbstreamdata.h
--- mythtv-0.21/libs/libmythtv/mpeg/dvbstreamdata.h	2008-02-27 00:37:42.000000000 +0100
+++ mythtv/libs/libmythtv/mpeg/dvbstreamdata.h	2009-01-17 09:23:55.000000000 +0100
@@ -182,6 +182,8 @@
     // Caching
     void CacheNIT(NetworkInformationTable*);
     void CacheSDT(ServiceDescriptionTable*);
+  protected:
+    virtual void DeleteCachedTable(PSIPTable *psip) const;
 
   private:
     /// DVB table monitoring
@@ -215,8 +217,8 @@
     sections_map_t            _sdto_section_seen;
 
     // Caching
-    nit_cache_t               _cached_nit;  // section -> sdt
-    sdt_cache_t               _cached_sdts; // tsid+section -> sdt
+    mutable nit_cache_t       _cached_nit;  // section -> sdt
+    mutable sdt_cache_t       _cached_sdts; // tsid+section -> sdt
 };
 
 inline void DVBStreamData::SetDishNetEIT(bool use_dishnet_eit)
diff -uNr mythtv-0.21/libs/libmythtv/mpeg/freesat_huffman.cpp mythtv/libs/libmythtv/mpeg/freesat_huffman.cpp
--- mythtv-0.21/libs/libmythtv/mpeg/freesat_huffman.cpp	1970-01-01 01:00:00.000000000 +0100
+++ mythtv/libs/libmythtv/mpeg/freesat_huffman.cpp	2008-12-02 22:58:50.000000000 +0100
@@ -0,0 +1,107 @@
+#include "freesat_huffman.h"
+
+#include <qstring.h>
+
+struct fsattab {
+    unsigned int value;
+    short bits;
+    char next;
+};
+
+#define START   '\0'
+#define STOP    '\0'
+#define ESCAPE  '\1'
+
+#include "freesat_tables.h"
+
+QString freesat_huffman_to_string(const unsigned char *src, uint size)
+{
+    if (src[1] == 1 || src[1] == 2)
+    {
+        QByteArray uncompressed(size * 3);
+        int p = 0;
+        unsigned value = 0, byte = 2, bit = 0;
+        while (byte < 6 && byte < size)
+        {
+            value |= src[byte] << ((5-byte) * 8);
+            byte++;
+        }
+        char lastch = START;
+
+        do
+        {
+            bool found = false;
+            unsigned bitShift = 0;
+            char nextCh = STOP;
+            if (lastch == ESCAPE)
+            {
+                found = true;
+                // Encoded in the next 8 bits.
+                // Terminated by the first ASCII character.
+                nextCh = (value >> 24) & 0xff;
+                bitShift = 8;
+                if ((nextCh & 0x80) == 0)
+                {
+                    if (nextCh < ' ')
+                        nextCh = STOP;
+                    lastch = nextCh;
+                }
+            }
+            else
+            {
+                unsigned indx = (unsigned)lastch;
+                if (src[1] == 2)
+                    indx |= 0x80;
+                for (unsigned j = fsat_index[indx]; j < fsat_index[indx+1]; j++)
+                {
+                    unsigned mask = 0, maskbit = 0x80000000;
+                    for (short kk = 0; kk < fsat_table[j].bits; kk++)
+                    {
+                        mask |= maskbit;
+                        maskbit >>= 1;
+                    }
+                    if ((value & mask) == fsat_table[j].value)
+                    {
+                        nextCh = fsat_table[j].next;
+                        bitShift = fsat_table[j].bits;
+                        found = true;
+                        lastch = nextCh;
+                        break;
+                    }
+                }
+            }
+            if (found)
+            {
+                if (nextCh != STOP && nextCh != ESCAPE)
+                {
+                    if (p >= uncompressed.count())
+                        uncompressed.resize(p+10);
+                    uncompressed[p++] = nextCh;
+                }
+                // Shift up by the number of bits.
+                for (unsigned b = 0; b < bitShift; b++)
+                {
+                    value = (value << 1) & 0xfffffffe;
+                    if (byte < size)
+                        value |= (src[byte] >> (7-bit)) & 1;
+                    if (bit == 7)
+                    {
+                        bit = 0;
+                        byte++;
+                    }
+                    else bit++;
+                }
+            }
+            else
+            {
+                // Entry missing in table.
+                QString result = QString::fromUtf8(uncompressed, p);
+                result.append("...");
+                return result;
+            }
+        } while (lastch != STOP && byte < size+4);
+
+        return QString::fromUtf8(uncompressed, p);
+    }
+    else return QString("");
+}
diff -uNr mythtv-0.21/libs/libmythtv/mpeg/freesat_huffman.h mythtv/libs/libmythtv/mpeg/freesat_huffman.h
--- mythtv-0.21/libs/libmythtv/mpeg/freesat_huffman.h	1970-01-01 01:00:00.000000000 +0100
+++ mythtv/libs/libmythtv/mpeg/freesat_huffman.h	2008-06-20 12:11:26.000000000 +0200
@@ -0,0 +1,12 @@
+#ifndef _FREESAT_HUFFMAN_H_
+#define _FREESAT_HUFFMAN_H_
+
+// POSIX header
+#include <unistd.h>
+
+// Qt header
+#include <qstring.h>
+
+QString freesat_huffman_to_string(const unsigned char *compressed, uint size);
+
+#endif // _FREESAT_HUFFMAN_H_
diff -uNr mythtv-0.21/libs/libmythtv/mpeg/mpegstreamdata.cpp mythtv/libs/libmythtv/mpeg/mpegstreamdata.cpp
--- mythtv-0.21/libs/libmythtv/mpeg/mpegstreamdata.cpp	2008-03-07 22:53:09.000000000 +0100
+++ mythtv/libs/libmythtv/mpeg/mpegstreamdata.cpp	2008-12-13 21:54:37.000000000 +0100
@@ -923,15 +923,16 @@
 }
 #undef DONE_WITH_PES_PACKET
 
-int MPEGStreamData::ProcessData(unsigned char *buffer, int len)
+int MPEGStreamData::ProcessData(const unsigned char *buffer, int len)
 {
     int pos = 0;
+    bool resync = false;
 
     while (pos + 187 < len) // while we have a whole packet left
     {
-        if (buffer[pos] != SYNC_BYTE)
+        if (buffer[pos] != SYNC_BYTE || resync)
         {
-            int newpos = ResyncStream(buffer, pos, len);
+            int newpos = ResyncStream(buffer, pos+1, len);
             if (newpos == -1)
                 return len - pos;
             if (newpos == -2)
@@ -942,9 +943,12 @@
 
         const TSPacket *pkt = reinterpret_cast<const TSPacket*>(&buffer[pos]);
         if (ProcessTSPacket(*pkt))
+        {
             pos += TSPacket::SIZE; // Advance to next TS packet
+            resync = false;
+        }
         else // Let it resync in case of dropped bytes
-            buffer[pos] = SYNC_BYTE + 1;
+            resync = true;
     }
 
     return len - pos;
@@ -995,7 +999,8 @@
     return true;
 }
 
-int MPEGStreamData::ResyncStream(unsigned char *buffer, int curr_pos, int len)
+int MPEGStreamData::ResyncStream(const unsigned char *buffer, int curr_pos,
+                                 int len)
 {
     // Search for two sync bytes 188 bytes apart, 
     int pos = curr_pos;
diff -uNr mythtv-0.21/libs/libmythtv/mpeg/mpegstreamdata.h mythtv/libs/libmythtv/mpeg/mpegstreamdata.h
--- mythtv-0.21/libs/libmythtv/mpeg/mpegstreamdata.h	2008-01-14 17:45:33.000000000 +0100
+++ mythtv/libs/libmythtv/mpeg/mpegstreamdata.h	2008-12-13 21:54:37.000000000 +0100
@@ -107,7 +107,7 @@
     virtual bool HandleTables(uint pid, const PSIPTable &psip);
     virtual void HandleTSTables(const TSPacket* tspacket);
     virtual bool ProcessTSPacket(const TSPacket& tspacket);
-    virtual int  ProcessData(unsigned char *buffer, int len);
+    virtual int  ProcessData(const unsigned char *buffer, int len);
     inline  void HandleAdaptationFieldControl(const TSPacket* tspacket);
 
     // Listening
@@ -293,7 +293,7 @@
     void ProcessPMT(const ProgramMapTable *pmt);
     void ProcessEncryptedPacket(const TSPacket&);
 
-    static int ResyncStream(unsigned char *buffer, int curr_pos, int len);
+    static int ResyncStream(const unsigned char *buffer, int curr_pos, int len);
 
     void UpdateTimeOffset(uint64_t si_utc_time);
 
diff -uNr mythtv-0.21/libs/libmythtv/mpeg/pespacket.cpp mythtv/libs/libmythtv/mpeg/pespacket.cpp
--- mythtv-0.21/libs/libmythtv/mpeg/pespacket.cpp	2006-09-07 20:55:03.000000000 +0200
+++ mythtv/libs/libmythtv/mpeg/pespacket.cpp	2009-01-15 22:12:48.000000000 +0100
@@ -6,10 +6,10 @@
 
 extern "C" {
 #include "mythconfig.h"
-#include "../libavcodec/avcodec.h"
-#include "../libavformat/avformat.h"
-#include "../libavutil/crc.h"
-#include "../libavutil/bswap.h"
+#include "libavcodec/avcodec.h"
+#include "libavformat/avformat.h"
+#include "libavutil/crc.h"
+#include "libavutil/bswap.h"
 }
 
 #include <vector>
@@ -333,21 +333,25 @@
 
 unsigned char *pes_alloc(uint size)
 {
+#ifndef USING_VALGRIND
     QMutexLocker locker(&pes_alloc_mutex);
     if (size <= 188)
         return get_188_block();
     else if (size <= 4096)
         return get_4096_block();
+#endif
     return (unsigned char*) malloc(size);
 }
 
 void pes_free(unsigned char *ptr)
 {
+#ifndef USING_VALGRIND
     QMutexLocker locker(&pes_alloc_mutex);
     if (is_188_block(ptr))
         return_188_block(ptr);
     else if (is_4096_block(ptr))
         return_4096_block(ptr);
     else
+#endif
         free(ptr);
 }
diff -uNr mythtv-0.21/libs/libmythtv/mpeg/scanstreamdata.cpp mythtv/libs/libmythtv/mpeg/scanstreamdata.cpp
--- mythtv-0.21/libs/libmythtv/mpeg/scanstreamdata.cpp	2006-11-06 19:18:46.000000000 +0100
+++ mythtv/libs/libmythtv/mpeg/scanstreamdata.cpp	2009-01-17 09:23:55.000000000 +0100
@@ -79,3 +79,14 @@
 
     return "mpeg";
 }
+
+
+void ScanStreamData::DeleteCachedTable(PSIPTable *psip) const
+{
+    if (!psip)
+        return;
+
+    ATSCStreamData::DeleteCachedTable(psip);
+    if (psip->pesdata())
+        DVBStreamData::DeleteCachedTable(psip);
+}
diff -uNr mythtv-0.21/libs/libmythtv/mpeg/scanstreamdata.h mythtv/libs/libmythtv/mpeg/scanstreamdata.h
--- mythtv-0.21/libs/libmythtv/mpeg/scanstreamdata.h	2006-11-06 19:18:46.000000000 +0100
+++ mythtv/libs/libmythtv/mpeg/scanstreamdata.h	2009-01-17 09:23:55.000000000 +0100
@@ -27,6 +27,9 @@
                           uint_vec_t& /*del_pids*/) const { return false; }
 
     QString GetSIStandard(QString guess = "mpeg") const;
+
+  private:
+    virtual void DeleteCachedTable(PSIPTable *psip) const;  
 };
 
 #endif // SCANSTREAMDATA_H_
